Debian Bug report logs - #602146
simh: h316 emu LDX instruction bug -- ea decoding performs indexing

version graph

Package: simh; Maintainer for simh is Vince Mulhollon <vlm@debian.org>; Source for simh is src:simh.

Reported by: drb@msu.edu

Date: Tue, 2 Nov 2010 00:51:02 UTC

Severity: normal

Tags: patch, sid, squeeze, upstream, wheezy

Found in version simh/3.8.1-2

Done: Vince Mulhollon <vince@mulhollon.com>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Vince Mulhollon <vlm@debian.org>:
Bug#602146; Package simh. (Tue, 02 Nov 2010 00:51:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to drb@msu.edu:
New Bug report received and forwarded. Copy sent to Vince Mulhollon <vlm@debian.org>. (Tue, 02 Nov 2010 00:51:05 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Dennis Boone <drb@msu.edu>
To: submit@bugs.debian.org
Subject: simh: h316 emu LDX instruction bug -- ea decoding performs indexing
Date: Mon, 01 Nov 2010 20:36:15 -0400
Subject: simh: h316 emu LDX instruction bug -- ea decoding performs indexing
Package: simh
Version: 3.8.1-2
Severity: normal
Tags: upstream squeeze sid patch

On the H316, the opcode for the LDX and STX instructions is the same.
The differentiation is made by setting or resetting the "do indexing"
bit of the instruction.

All instructions in the emulator use the Ea() routine to compute the
effective address to be addressed by the instruction.  There's no
way to tell Ea() that LDX and STX are special.  The case statement
block for these two instructions, in version 3.8-0, masked off the
"do index" bit before calling Ea().

Per an email conversation with upstream, this masking was inadvertently
removed in a code cleanup in the 3.8-1 release, and should reappear
in the 3.8-2 release.  ("...if I can ever find the time to get it out
the door.")

I've attached a patch which corrects the issue.  It might save somebody
some debugging time.

De

-- System Information:
Debian Release: squeeze/sid
  APT prefers unstable
  APT policy: (500, 'unstable')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.32-5-amd64 (SMP w/4 CPU cores)
Locale: LANG=en_US.UTF-8, LC_CTYPE=es_US.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages simh depends on:
ii  libc6                         2.11.2-2   Embedded GNU C Library: Shared lib

simh recommends no packages.

simh suggests no packages.

-- no debconf information


diff -ur simh-3.8.1/H316/h316_cpu.c simh-3.8.1-drb/H316/h316_cpu.c
--- simh-3.8.1/H316/h316_cpu.c	2008-11-21 20:12:32.000000000 -0500
+++ simh-3.8.1-drb/H316/h316_cpu.c	2010-11-01 20:15:54.000000000 -0400
@@ -614,13 +614,13 @@
         break;
 
     case 015: case 055:                                 /* STX */
-        if (reason = Ea (MB, &Y))                       /* eff addr */
+        if (reason = Ea (MB & ~IDX, &Y))                /* eff addr */
             break;
         Write (Y, XR);                                  /* store XR */
         break;
 
     case 035: case 075:                                 /* LDX */
-        if (reason = Ea (MB, &Y))                       /* eff addr */
+        if (reason = Ea (MB & ~IDX, &Y))                /* eff addr */
             break;
         XR = Read (Y);                                  /* load XR */
         break;




Added tag(s) wheezy. Request was from Kurt Roeckx <kurt@roeckx.be> to control@bugs.debian.org. (Wed, 16 Feb 2011 19:04:52 GMT) Full text and rfc822 format available.

Reply sent to Vince Mulhollon <vince@mulhollon.com>:
You have taken responsibility. (Thu, 07 Jul 2011 02:21:04 GMT) Full text and rfc822 format available.

Notification sent to drb@msu.edu:
Bug acknowledged by developer. (Thu, 07 Jul 2011 02:21:04 GMT) Full text and rfc822 format available.

Message #12 received at 602146-done@bugs.debian.org (full text, mbox):

From: Vince Mulhollon <vince@mulhollon.com>
To: 602146-done@bugs.debian.org
Subject: [vlm@debian.org: Accepted simh 3.8.1-3 (source amd64)]
Date: Wed, 6 Jul 2011 21:17:13 -0500
Hmm, made a mistake in the changelog, listed the wrong bug number
thus this did not get closed when I uploaded the new package...

----- Forwarded message from Vince Mulhollon <vlm@debian.org> -----

Date: Wed, 06 Jul 2011 19:21:07 +0000
From: Vince Mulhollon <vlm@debian.org>
To: debian-devel-changes@lists.debian.org
Subject: Accepted simh 3.8.1-3 (source amd64)

-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Wed, 06 Jul 2011 05:07:45 -0500
Source: simh
Binary: simh
Architecture: source amd64
Version: 3.8.1-3
Distribution: unstable
Urgency: low
Maintainer: Vince Mulhollon <vlm@debian.org>
Changed-By: Vince Mulhollon <vlm@debian.org>
Description: 
 simh       - Emulators for 33 different computers
Closes: 631834
Changes: 
 simh (3.8.1-3) unstable; urgency=low
 .
   * Rename nova to dgnova because of collision with python-novaclient
     (Closes: #631834)
   * Bump standards version from 3.8.4.0 to 3.9.1.0
   * Dynamically link in libpcap instead of static link
     fixes lintian embedded-library errors for pdp10 pdp11 vax
     This also adds a dependency for the .deb on libpcap0.8
   * fixed spelling error in hp2100_ipl.c from connnection to
     connection.  Fixes lintian spelling-error-in-binary for hp2100
   * escaped - in macro8x.1 to fix lintian "hyphen-used-as-minus-sign"
   * A first attempt at a debian/watch file
   * Applied Dennis Boone's patch to fix the H316 LDX instuction
     See H316/h316_cpu.c in the case statement for STX and LDX
     (Closes: #631834)
   * Explicitly set source format 1.0 (for now) in debian/source/format
     This makes lintian happy, missing-debian-source-format goes away
     Eventually I'll switch to Quilt-3.0 format, just not today.
Checksums-Sha1: 
 8b3cc521641afe5b2fc565af90e087aa06ef6cba 973 simh_3.8.1-3.dsc
 4bb691c77585f1a9cf9462ad7fd28af71e746292 29153 simh_3.8.1-3.diff.gz
 0300891ba18da50f590befe0cdff879a26828c1e 4916630 simh_3.8.1-3_amd64.deb
Checksums-Sha256: 
 597e3600839c3d3184f9a28f8e88a056124d12a8c299450c298a1579745ce980 973 simh_3.8.1-3.dsc
 c370174fe4b6123db3c47a85062c708afd07c639b313fcb7ce80890271efdea4 29153 simh_3.8.1-3.diff.gz
 c0b35dde0eec0f2e918a8bdbc30cb13d2e124c8445ef3c6ac1324027db7447bb 4916630 simh_3.8.1-3_amd64.deb
Files: 
 5ead0b7aaf5743f8e9e3dea0bf1491f8 973 otherosfs optional simh_3.8.1-3.dsc
 f276f461157785124733e73f02fa1216 29153 otherosfs optional simh_3.8.1-3.diff.gz
 cc4970f15b7737c791f71d0d8953cf8c 4916630 otherosfs optional simh_3.8.1-3_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iD8DBQFOFK+x4oRQ9gHTq5MRAuSZAJ0cK7kvIns5f7z5tiEBFYx/pQr2wACfeyNI
KnqSLDy+xz5bZiy1C5bRCy0=
=JUMF
-----END PGP SIGNATURE-----


Accepted:
simh_3.8.1-3.diff.gz
  to main/s/simh/simh_3.8.1-3.diff.gz
simh_3.8.1-3.dsc
  to main/s/simh/simh_3.8.1-3.dsc
simh_3.8.1-3_amd64.deb
  to main/s/simh/simh_3.8.1-3_amd64.deb



----- End forwarded message -----




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Thu, 04 Aug 2011 07:33:55 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Fri Apr 18 05:44:51 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.